/* Copyright (C) 1992-2023 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library.  If not, see
   <http://www.gnu.org/licenses/>.  */

#define __ASSEMBLY__

#include <sysdep.h>
#include <pointer_guard.h>
#include <jmpbuf-offsets.h>


ENTRY(__longjmp)
#ifdef PROF
	ldgp    gp, 0(pv)
	.set noat
	ldi     AT, _mcount
	call     AT, (AT), _mcount
	.set at
	.prologue 1
#else
	.prologue 0
#endif

	mov     a1, v0
	ldl     s0, JB_S0*8(a0)
	ldl     s1, JB_S1*8(a0)
	ldl     s2, JB_S2*8(a0)
	ldl     s3, JB_S3*8(a0)
	ldl     s4, JB_S4*8(a0)
	ldl     s5, JB_S5*8(a0)
	ldl     ra, JB_PC*8(a0)
	ldl     fp, JB_FP*8(a0)
	ldl     t0, JB_SP*8(a0)
	fldd     $f2, JB_F2*8(a0)
	fldd     $f3, JB_F3*8(a0)
	fldd     $f4, JB_F4*8(a0)
	fldd     $f5, JB_F5*8(a0)
	fldd     $f6, JB_F6*8(a0)
	fldd     $f7, JB_F7*8(a0)
	fldd     $f8, JB_F8*8(a0)
	fldd     $f9, JB_F9*8(a0)
#ifdef PTR_DEMANGLE
	PTR_DEMANGLE(ra, t1)
	PTR_DEMANGLE2(t0, t1)
	PTR_DEMANGLE2(fp, t1)
#endif
	seleq  v0, 1, v0, v0
	mov     t0, sp
	ret

END(__longjmp)
